"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const LOGS_CONFIG = {
    saveConsoleOutput: true,
    dir: 'logs',
    files: { main: '', fatal: '', net: '', app: '', seq: '' },
    options: {
        appenders: {
            out: { type: 'console', maxLogSize: 10000000, backups: 10 },
            seq: { type: 'file', maxLogSize: 1000000000, backups: 10 },
            main: { type: 'file', maxLogSize: 10000000, backups: 10 },
            app: { type: 'file', maxLogSize: 10000000, backups: 10 },
            p2p: { type: 'file', maxLogSize: 10000000, backups: 10 },
            snapshot: { type: 'file', maxLogSize: 10000000, backups: 10 },
            cycle: { type: 'file', maxLogSize: 10000000, backups: 10 },
            fatal: { type: 'file', maxLogSize: 10000000, backups: 10 },
            exit: { type: 'file', maxLogSize: 10000000, backups: 10 },
            errorFile: { type: 'file', maxLogSize: 10000000, backups: 10 },
            errors: { type: 'logLevelFilter', level: 'ERROR', appender: 'errorFile' },
            net: { type: 'file', maxLogSize: 10000000, backups: 10 },
            playback: { type: 'file', maxLogSize: 10000000, backups: 10 },
            shardDump: { type: 'file', maxLogSize: 10000000, backups: 10 },
            statsDump: { type: 'file', maxLogSize: 10000000, backups: 10 },
        },
        categories: {
            default: { appenders: ['out'], level: 'trace' },
            app: { appenders: ['app', 'errors'], level: 'trace' },
            main: { appenders: ['main', 'errors'], level: 'trace' },
            seq: { appenders: ['seq'], level: 'trace' },
            p2p: { appenders: ['p2p'], level: 'trace' },
            snapshot: { appenders: ['snapshot'], level: 'trace' },
            cycle: { appenders: ['cycle'], level: 'trace' },
            fatal: { appenders: ['fatal'], level: 'fatal' },
            exit: { appenders: ['exit'], level: 'fatal' },
            net: { appenders: ['net'], level: 'trace' },
            playback: { appenders: ['playback'], level: 'trace' },
            shardDump: { appenders: ['shardDump'], level: 'trace' },
            statsDump: { appenders: ['statsDump'], level: 'trace' },
        },
    },
};
exports.default = LOGS_CONFIG;
//# sourceMappingURL=logs.js.map