/// <reference types="node" />
/// <reference types="node" />
import { Got } from 'got';
export declare function customGot(maxBytes?: number): Got;
/**
 * A custom fetch function with size limiting.
 * @param input URL or Request object.
 * @param init Optional fetch configuration.
 * @param maxBytes Maximum response size in bytes (default: config.p2p.maxResponseSize).
 * @returns A Response with a ReadableStream that enforces the download limit.
 */
export declare function customFetch(input: string | Request | URL, init?: RequestInit, maxBytes?: number): Promise<Response>;
