/**
 * `verify` submodule. Defines functions used to verify objects against
 * given hashes.
 */
import { P2P, hexstring } from '@shardeum-foundation/lib-types';
import { Result } from 'neverthrow';
/** Verifies that the hash of the validator list matches the expected hash. */
export declare function verifyValidatorList(validatorList: P2P.NodeListTypes.Node[], expectedHash: hexstring): Result<boolean, Error>;
/** Verifies that the hash of the archiver list matches the expected hash. */
export declare function verifyArchiverList(archiverList: P2P.ArchiversTypes.JoinedArchiver[], expectedHash: hexstring): Result<boolean, Error>;
/** Verifies that the hash of the cycle record matches the expected hash. */
export declare function verifyCycleRecord(cycleRecord: P2P.CycleCreatorTypes.CycleRecord, expectedHash: hexstring): Result<boolean, Error>;
export declare function verifyTxList(txList: {
    hash: string;
    tx: P2P.ServiceQueueTypes.AddNetworkTx;
}[], expectedHash: hexstring): Result<boolean, Error>;
