import { VectorBufferStream } from '../utils/serialization/VectorBufferStream';
export declare const cGetTrieAccountHashesRespVersion = 1;
export declare const cRadixAndChildHashesVersion = 1;
export type GetTrieAccountHashesResp = {
    nodeChildHashes: RadixAndChildHashes[];
    stats: {
        matched: number;
        visisted: number;
        empty: number;
        childCount: number;
    };
};
export type RadixAndChildHashes = {
    radix: string;
    childAccounts: AccountIDAndHash[];
};
export type AccountIDAndHash = {
    accountID: string;
    hash: string;
};
export declare function serializeGetTrieAccountHashesResp(stream: VectorBufferStream, req: GetTrieAccountHashesResp, root?: boolean): void;
export declare function deserializeGetTrieAccountHashesResp(stream: VectorBufferStream): GetTrieAccountHashesResp;
export declare function serializeRadixAndChildHashes(stream: VectorBufferStream, req: RadixAndChildHashes, root?: boolean): void;
export declare function deserializeRadixAndChildHashes(stream: VectorBufferStream): RadixAndChildHashes;
