"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initSignAppDataReq = exports.schemaSignAppDataReq = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
exports.schemaSignAppDataReq = {
    type: 'object',
    properties: {
        type: { type: 'string' },
        nodesToSign: { type: 'number' },
        hash: { type: 'string' },
        appData: {}, // type unknown
    },
    required: ['type', 'nodesToSign', 'hash', 'appData'],
};
function initSignAppDataReq() {
    addSchemaDependencies();
    addSchemas();
}
exports.initSignAppDataReq = initSignAppDataReq;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.SignAppDataReq, exports.schemaSignAppDataReq);
}
//# sourceMappingURL=SignAppDataReq.js.map