"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initWrappedData = exports.schemaWrappedData = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
exports.schemaWrappedData = {
    type: 'object',
    properties: {
        accountId: { type: 'string' },
        stateId: { type: 'string' },
        data: {},
        timestamp: { type: 'number' },
        syncData: {
            anyOf: [
                { type: 'object', additionalProperties: true },
                { type: 'string' },
                { type: 'number' },
                { type: 'boolean' },
                { type: 'array' },
                { type: 'null' },
            ],
        },
    },
    required: ['accountId', 'stateId', 'data', 'timestamp'],
};
function initWrappedData() {
    addSchemaDependencies();
    addSchemas();
}
exports.initWrappedData = initWrappedData;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)('WrappedData', exports.schemaWrappedData);
}
//# sourceMappingURL=WrappedData.js.map