"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initSendCachedAppDataReq = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
const CachedAppData_1 = require("./CachedAppData");
const schemaSendCachedAppDataReq = {
    type: 'object',
    properties: {
        topic: { type: 'string' },
        txId: { type: 'string' },
        executionShardKey: { type: 'string' },
        cachedAppData: CachedAppData_1.schemaCachedAppData,
    },
    required: ['topic', 'cachedAppData', 'executionShardKey', 'txId'],
    additionalProperties: false,
};
function initSendCachedAppDataReq() {
    addSchemaDependencies();
    addSchemas();
}
exports.initSendCachedAppDataReq = initSendCachedAppDataReq;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.SendCachedAppDataReq, schemaSendCachedAppDataReq);
}
//# sourceMappingURL=sendCachedAppDataReq.js.map